﻿<%@ Page aspCompat="True" Language="VB" %>

<%@ Import Namespace="MigraDoc.DocumentObjectModel" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="PdfSharp" %>
<%@ Import Namespace="PdfSharp.Drawing" %>
<%@ Import Namespace="PdfSharp.Pdf" %>
<%@ Import Namespace="PdfSharp.Pdf.IO" %>
<%@ Import Namespace="MigraDoc.DocumentObjectModel" %>
<%@ Import Namespace="MigraDoc.Rendering" %>

<script runat="server" >
    Const iFontSize As Integer = 8
    Const iFontName As String = "Arial"
    Const dRowHeight As Double = 0.5
    Const iTopMargin As Double = 1.0
    Const iSideMargin As Double = 1.2
        
    Protected Overloads Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)
        
        'pdf
        Dim pdfDoc As PdfDocument = New PdfDocument
        Dim page As PdfPage = pdfDoc.AddPage
        pdfDoc.Info.Title = "test"
        pdfDoc.Info.Author = "WWW.VVICT.NL"
        page.Size = PageSize.A4
        
        'migradoc
        Dim doc As Document = New Document
        Dim sec As Section = doc.AddSection()
        
        SetStyles(doc, MigraDoc.DocumentObjectModel.Unit.FromCentimeter("21"))
        Dim docRenderer As MigraDoc.Rendering.DocumentRenderer = New MigraDoc.Rendering.DocumentRenderer(doc)
        docRenderer.PrepareDocument()
                
        Dim strTitel As String = "Titel van het rapport"
        
        Dim xpos As Double = 0
        Dim ypos As Double = 0

        'begin bovenaan bij de marge
        ypos = iTopMargin
        
        Dim gfx As XGraphics = XGraphics.FromPdfPage(page)
        docRenderer.RenderObject(gfx, FC(iSideMargin), FC(ypos), FC(8), AddHeader(sec, docRenderer))
        docRenderer.RenderObject(gfx, FC(iSideMargin), FC(28.5), FC(8), AddFooter(sec, docRenderer))
        ypos += 1
        
        For Each rw As Char In "abcdefg"
            
            docRenderer.RenderObject(gfx, FC(iSideMargin), FC(ypos), FC(6), GewoneTekst(rw, sec))
            docRenderer.RenderObject(gfx, FC(iSideMargin + 15), FC(ypos - 0.1), FC(8), OptieBlok("101010", sec))

            ypos += dRowHeight
            
            If ypos > 30 Then
                gfx = XGraphics.FromPdfPage(pdfDoc.AddPage)
                ypos = 0
            Else
                Dim pen As XPen = New XPen(XColor.FromArgb(65, 140, 192))
                pen.Width = 0.4
                Dim vPos As Double = FC(ypos).Point
                Dim hPos As Double = FC(iSideMargin).Point
                gfx.DrawLine(pen, hPos, vPos, page.Width.Point - hPos + 10, vPos)
                ypos += 0.1
            End If
        Next
              
        Dim filename As String = "deelnemerslijst.pdf"
        Dim stream As MemoryStream = New MemoryStream

        pdfDoc.Save(stream, False)
        Response.Clear()
        Response.ContentType = "application/pdf"
        Response.AddHeader("content-length", stream.Length.ToString())
        Response.BinaryWrite(stream.ToArray())
        Response.Flush()
        stream.Close()
        Response.End()
    End Sub
    
    Function FC(ByVal argDouble As Double) As PdfSharp.Drawing.XUnit
        Return XUnit.FromCentimeter(argDouble)
    End Function
    
    Function AddHeader(ByRef argSect As Section, ByRef argDocrenderer As MigraDoc.Rendering.DocumentRenderer) As Paragraph
        
        Dim para As Paragraph = argSect.AddParagraph()
        para.Style = StyleNames.Normal
        para.Format.Alignment = ParagraphAlignment.Left
        para.Format.Font.Name = "Arial"
        para.Format.Font.Color = MigraDoc.DocumentObjectModel.Colors.Black
        para.Format.Font.Size = MigraDoc.DocumentObjectModel.Unit.FromPoint(iFontSize)
        para.AddText("Deelnemerslijst: ")
        para.AddTab()
        para.AddText("titel")
        para.AddLineBreak()
        para.AddText("Datum:")
        para.AddTab()
        para.AddTab()
        para.AddText("test")
        
        Return para
    End Function
    
    Function AddFooter(ByRef argSect As Section, ByRef argDocrenderer As MigraDoc.Rendering.DocumentRenderer) As Paragraph
        
        Dim para As Paragraph = argSect.AddParagraph()
        para.Style = StyleNames.Normal
        para.Format.Alignment = ParagraphAlignment.Left
        para.Format.Font.Name = "Arial"
        para.Format.Font.Size = MigraDoc.DocumentObjectModel.Unit.FromPoint(iFontSize)
        para.Format.Font.Color = MigraDoc.DocumentObjectModel.Colors.DarkGray
        para.AddText("Aangemaakt: " + Now.ToLongDateString + " " + Now.ToShortTimeString)
        para.Format.TabStops.ClearAll()
        para.Format.AddTabStop("25cm", TabAlignment.Right)
        para.AddTab()
        para.AddTab()
        para.AddText("Pagina:")
        para.AddLineBreak()
            
        Return para
    End Function
    
    Function GewoneTekst(ByVal argText As String, ByRef argSect As Section) As Paragraph
        
        'teken de interessevakjes
        Dim para As Paragraph = argSect.AddParagraph
        para.Style = StyleNames.Normal
        
        '============ IF I COMMENT THE OUT, I GET EM_SIZE ERROR ======================
        para.Format.Alignment = ParagraphAlignment.Left
        para.Format.Font.Name = iFontName
        para.Format.Font.Size = MigraDoc.DocumentObjectModel.Unit.FromPoint(iFontSize)
        para.Format.Font.Color = MigraDoc.DocumentObjectModel.Colors.Black
        '=============================================================================
        
        If argText Is Nothing Then argText = ""
        para.AddText(argText)
        para.AddLineBreak()
        Return para
    End Function
    
    Function OptieBlok(ByVal argOpties As String, ByRef argSect As Section) As Paragraph
        
        'teken de interessevakjes
        Dim para As Paragraph = argSect.AddParagraph
        para.Style = StyleNames.Normal
        Dim optieStr As String = String.Empty
        para.Format.Alignment = ParagraphAlignment.Left
        para.Format.Font.Name = "Wingdings"
        para.Format.Font.Size = MigraDoc.DocumentObjectModel.Unit.FromPoint(13)
        para.Format.Font.Color = MigraDoc.DocumentObjectModel.Colors.Black

        For Each car As String In argOpties
            If car = "1" Then
                optieStr += Chr(254) + ""
            Else
                optieStr += Chr(168) + ""
            End If
        Next
                 
        para.AddText(optieStr)
        Return para
    End Function
    
    Private Sub SetStyles(ByVal Doc As Document, ByVal ContentWidth As MigraDoc.DocumentObjectModel.Unit)
        
        With Doc.Styles(StyleNames.Normal).Font
            .Name = "Tahoma"
            .Size = 10
        End With
        Doc.Styles(StyleNames.Header).ParagraphFormat.AddTabStop(ContentWidth, TabAlignment.Right)
        Doc.Styles(StyleNames.Footer).Font.Size = 7
        With Doc.Styles.AddStyle("Title", StyleNames.Normal)   'Extends normal
            .Font.Size = 12
            .Font.Bold = True
            .ParagraphFormat.SpaceBefore = 15
            .ParagraphFormat.SpaceAfter = 15
            .ParagraphFormat.Borders.Top.Width = 1
        End With
        Doc.Styles.AddStyle("TermTitle", StyleNames.Normal).Font.Bold = True
    End Sub
  </script>
